
#include <fstream.h>
#include <math.h>
#include <conio.h>
#include <stdlib.h>


namespace ToneFFT
{

const gmCount=7;

const DigitCount=12;	// 


const N=512;	//  -     gm[]

			 /*    0  1     2     3     4    5      6 */
static int gm[gmCount]={ 32, 36,  40,   44,   56,   62,   69}; //68 ???
			//	 697, 770, 852,	 941,  1209, 1336, 1477
const double PI=3.1415926;

static double SIN[gmCount][N];
static double COS[gmCount][N];

struct GARMONYK
{
	int a,	//
	 n;	//
};

//  n   
static float fft(int n, float N, unsigned char *y)
{
	float Asn=0, Acn=0;
	for(int i=1; i<N; i++)
	{
		int Y=y[i];
		Asn+=Y*SIN[n][i];
		Acn+=Y*COS[n][i];
	}

	Asn=Asn*2/N;
	Acn=Acn*2/N;

	return sqrt(Asn*Asn+Acn*Acn);
}

static int digit[DigitCount][3]=
{
	{ 3,5, '0' },
	{ 0,4, '1' },
	{ 0,5, '2' },
	{ 0,6, '3' },
	{ 1,4, '4' },
	{ 1,5, '5' },
	{ 1,6, '6' },
	{ 2,4, '7' },
	{ 2,5, '8' },
	{ 2,6, '9' },
	{ 3,4, '*' },
	{ 3,6, '#' }
};

//  -
void DTFM_initSinCosTable()
{
	for(int j=0; j<gmCount; j++)
	for(int i=0; i<=N; i++)
	{
		float p=2*PI*gm[j]*i/N;
		SIN[j][i]=sin(p);
		COS[j][i]=cos(p);
	}
}

//   : 0,1, ...11,12
// (-1) -    
//ToneDate -    (512 ), 
//  
//  11025   
char ToneAnalyse(unsigned char *ToneDate)
{

	GARMONYK garm[gmCount];

	for(int i=0;i<gmCount;i++)
		{
			garm[i].a=fft(i,N,ToneDate);
			garm[i].n=i;
		}

	//㥬
	for(i=0;i<gmCount;i++)
	for(int j=0;j<gmCount;j++)
	{
		if(garm[j].a<garm[i].a)
		{
			GARMONYK temp=garm[i];
			garm[i]=garm[j];
			garm[j]=temp;
		}
	}

	int found=0;
	for(int j=0; j<DigitCount; j++)
	{
			int	a=digit[j][0],
				b=digit[j][1],
				a2=garm[0].n,
				b2=garm[1].n;
		if ( (a == a2 && b==b2) || (a==b2 && b==a2) )
		{

			if (garm[0].a>13 && garm[1].a>12)
			{

				found=1;
				return j;
			}

		}
	}

	//if (!found) 
		
	return  -1;

}

};